QCPItemStraightLine Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Functions | Public Members | Protected Functions
QCPItemStraightLine Class Reference

A straight line that spans infinitely in both directions. More...

Inheritance diagram for QCPItemStraightLine:

## Public Functions
| QCPItemStraightLine (QCustomPlot *parentPlot)
QPen | pen () const
QPen | selectedPen () const
void | setPen (const QPen &pen)
void | setSelectedPen (const QPen &pen)
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=0) const
Public Functions inherited from QCPAbstractItem
| QCPAbstractItem (QCustomPlot *parentPlot)
bool | clipToAxisRect () const
QCPAxisRect * | clipAxisRect () const
bool | selectable () const
bool | selected () const
void | setClipToAxisRect (bool clip)
void | setClipAxisRect (QCPAxisRect *rect)
Q_SLOT void | setSelectable (bool selectable)
Q_SLOT void | setSelected (bool selected)
QList< QCPItemPosition * > | positions () const
QList< QCPItemAnchor * > | anchors () const
QCPItemPosition * | position (const QString &name) const
QCPItemAnchor * | anchor (const QString &name) const
bool | hasAnchor (const QString &name) const
Public Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer=QString(), QCPLayerable *parentLayerable=0)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
Q_SLOT bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Public Members
QCPItemPosition *const | point1
QCPItemPosition *const | point2

## Protected Functions
virtual void | draw (QCPPainter *painter)
double | distToStraightLine (const QVector2D &point1, const QVector2D &vec, const QVector2D &point) const
QLineF | getRectClippedStraightLine (const QVector2D &point1, const QVector2D &vec, const QRect &rect) const
QPen | mainPen () const
Protected Functions inherited from QCPAbstractItem
virtual QCP::Interaction | selectionCategory () const
virtual QRect | clipRect () const
virtual void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
virtual QPointF | anchorPixelPoint (int anchorId) const
double | distSqrToLine (const QPointF &start, const QPointF &end, const QPointF &point) const
double | rectSelectTest (const QRectF &rect, const QPointF &pos, bool filledRect) const
QCPItemPosition * | createPosition (const QString &name)
QCPItemAnchor * | createAnchor (const QString &name, int anchorId)
Protected Functions inherited from QCPLayerable
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Additional Inherited Members
Signals inherited from QCPAbstractItem
void | selectionChanged (bool selected)
void | selectableChanged (bool selectable)
Signals inherited from QCPLayerable
void | layerChanged (QCPLayer *newLayer)

## Detailed Description

A straight line that spans infinitely in both directions.

Straight line example. Blue dotted circles are anchors, solid blue discs are positions.

It has two positions, point1 and point2, which define the straight line.

## Constructor & Destructor Documentation

QCPItemStraightLine::QCPItemStraightLine | ( | QCustomPlot * | parentPlot | ) |

Creates a straight line item and sets default values.

The constructed item can be added to the plot with QCustomPlot::addItem.

## Member Function Documentation

void QCPItemStraightLine::setPen | ( | const QPen & | pen | ) |

Sets the pen that will be used to draw the line

See Also
  setSelectedPen

void QCPItemStraightLine::setSelectedPen | ( | const QPen & | pen | ) |

Sets the pen that will be used to draw the line when selected

See Also
  setPen, setSelected

double QCPItemStraightLine::selectTest | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | details = `0`
| ) |  | const
| virtual

This function is used to decide whether a click hits a layerable object or not.

pos is a point in pixel coordinates on the QCustomPlot surface. This function returns the shortest pixel distance of this point to the object. If the object is either invisible or the distance couldn't be determined, -1.0 is returned. Further, if onlySelectable is true and the object is not selectable, -1.0 is returned, too.

If the object is represented not by single lines but by an area like a QCPItemText or the bars of a QCPBars plottable, a click inside the area should also be considered a hit. In these cases this function thus returns a constant value greater zero but still below the parent plot's selection tolerance. (typically the selectionTolerance multiplied by 0.99).

Providing a constant value for area objects allows selecting line objects even when they are obscured by such area objects, by clicking close to the lines (i.e. closer than 0.99*selectionTolerance).

The actual setting of the selection state is not done by this function. This is handled by the parent QCustomPlot when the mouseReleaseEvent occurs, and the finally selected object is notified via the selectEvent/deselectEvent methods.

details is an optional output parameter. Every layerable subclass may place any information in details. This information will be passed to selectEvent when the parent QCustomPlot decides on the basis of this selectTest call, that the object was successfully selected. The subsequent call to selectEvent will carry the details. This is useful for multi-part objects (like QCPAxis). This way, a possibly complex calculation to decide which part was clicked is only done once in selectTest. The result (i.e. the actually clicked part) can then be placed in details. So in the subsequent selectEvent, the decision which part was selected doesn't have to be done a second time for a single selection operation.

You may pass 0 as details to indicate that you are not interested in those selection details.

See Also
  selectEvent, deselectEvent, QCustomPlot::setInteractions

Implements QCPAbstractItem.

void QCPItemStraightLine::draw | ( | QCPPainter * | painter | ) |
| protectedvirtual

Draws this item with the provided painter.

The cliprect of the provided painter is set to the rect returned by clipRect before this function is called. The clipRect depends on the clipping settings defined by setClipToAxisRect and setClipAxisRect.

Implements QCPAbstractItem.

double QCPItemStraightLine::distToStraightLine | ( | const QVector2D & | base,
|  | const QVector2D & | vec,
|  | const QVector2D & | point
| ) |  | const
| protected

finds the shortest distance of point to the straight line defined by the base point base and the direction vector vec.

This is a helper function for selectTest.

QLineF QCPItemStraightLine::getRectClippedStraightLine | ( | const QVector2D & | base,
|  | const QVector2D & | vec,
|  | const QRect & | rect
| ) |  | const
| protected

Returns the section of the straight line defined by base and direction vector vec, that is visible in the specified rect.

This is a helper function for draw.

QPen QCPItemStraightLine::mainPen | ( |  | ) | const
| protected

Returns the pen that should be used for drawing lines. Returns mPen when the item is not selected and mSelectedPen when it is.

The documentation for this class was generated from the following files:

- src/items/item-straightline.h
- src/items/item-straightline.cpp